package com.lantone.qc.kernel.catalogue.behospitalized;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.entity.Drinking;
import com.lantone.qc.pub.model.label.PersonalLabel;
import com.lantone.qc.pub.util.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @Description: 饮酒史未描述
 * @author: rengb
 * @time: 2020/3/10 14:02
 */
@Component
public class BEH0047 extends QCCatalogue {

    @Override
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        if (inputInfo.getBeHospitalizedDoc() == null) {
            status.set("0");
            return;
        }
        Map<String, String> structureMap = inputInfo.getBeHospitalizedDoc().getStructureMap();
        if (StringUtils.isNotEmpty(structureMap.get("饮酒"))) {
            status.set("0");
            return;
        }
        PersonalLabel personalLabel = inputInfo.getBeHospitalizedDoc().getPersonalLabel();
        if (personalLabel == null || StringUtil.isBlank(personalLabel.getText())) {
            status.set("0");
            return;
        }
        String pastText = personalLabel.getText();
        if (pastText.contains("饮酒") || pastText.contains("详见原病历")) {
            status.set("0");
            return;
        }

        Drinking drinking = personalLabel.getDrinking();
        if (drinking != null && StringUtil.isNotBlank(drinking.getName())) {
            status.set("0");
        }
        //硬匹配规则
        if (inputInfo.getBeHospitalizedDoc().getPersonalLabel().getText().contains("酒")) {
            status.set("0");
        }
    }
}
